;
; MAPPING SOL
;

vitessey	equ 4
Nblig	equ 100
Hobs	equ 1000
focale	equ 10

debut	clr.l -(sp)
	move.w #32,-(sp)
	trap #1
	move.l d0,2(sp)
	
	move.w #90,angle
	jsr Precalc
	
	move.l $44E.w,old_screen
	
	move.w #-1,-(sp)
	move.w #$58,-(sp)
	trap #14
	addq.w #4,sp
	move.w d0,old_mode
	and.w #$30,d0
	or.w #$004,d0

	move.b #2,$484.w

	move.l #ecran+4,d1
	and.b #$FC,d1
	move.l d1,p_ecran
	
	move.w d0,-(sp)
	move.w #3,-(sp)
	move.l p_ecran,-(sp) 	
	move.l p_ecran,-(sp) 	
	move.w #5,-(sp)
	trap #14
	add.w #14,sp	
	
	bsr Precalc
	
.at_vbl	sf $465.w
.at_	tst.b $465.w
	beq.s .at_
	move.l #$ff000000,$ffff9800.w
	bsr Aff
	move.l #-1,$ffff9800.w
	cmp.b #$4b,$fffffc02.w
	bne.s .p4b
	add.w #1,angle
	cmp.w #360,angle
	blo.s .p4b
	clr.w angle
.p4b	cmp.b #$4d,$fffffc02.w
	bne.s .p4d
	subq.w #1,angle
	bpl.s .p4d
	move.w #359,angle
.p4d
.wait	cmp.b #$39,$fffffc02.w
	bne.s .at_vbl
.wa	cmp.b #$39+$80,$fffffc02.w
	bne.s .wa
	
	move.w old_mode,-(sp)
	move.w #3,-(sp)
	move.l old_screen,-(sp) 	
	move.l old_screen,-(sp) 	
	move.w #5,-(sp)
	trap #14
	add.w #14,sp	
	
	trap #1
	addq.w #6,sp
	clr.w -(sp)
	trap #1
	
; Precalcule la table des distances...
Precalc	move.l #Hobs,d7
	addq.l #1,d7
	lea distance+Nblig*4,a0
	moveq #Nblig-1,d0
.loop	move.l #focale,d6
	mulu d7,d6		;Hobs*focale
	move.l d0,d5
	addq.l #1,d5
	divs.l d5,d6	;(Hob+1s*focale)/(y+1)
	move.l d6,-(a0)
	dbra d0,.loop
	rts
	
Aff	move.l p_ecran,a0
	add.l #640*100,a0
	lea distance,a1
	moveq #Nblig-1,d0
	move.w angle,d2	;angle !
	lsl.w #2,d2		;*4 car cos et sin
next_lig	
	move.l (a1),d1	;On cherche X DEPART
	move.w d2,d3	;distance !
	add.w #30*4,d3
	cmp.w #360*4,d3
	blo.s .inf0
	sub.w #360*4,d3
.inf0	muls (cosinus,d3.w),d1	
	asr.l #8,d1
	asr.l #2,d1		;x de depart ds la texture
	and.l #127,d1	;modulo dans la texture
	
	move.l (a1),d4	;On cherche Y DEPART
	move.w d2,d3	;distance !
	add.w #30*4,d3
	cmp.w #360*4,d3
	blo.s .inf1
	sub.w #360*4,d3
.inf1	muls (cosinus+2,d3.w),d4	
	asr.l #8,d4
	asr.l #2,d4		;y de depart ds la texture
	and.l #63,d4	;modulo dans la texture
	moveq #64,d6
	sub.l d4,d6
	move.l d6,d4
	
	move.l (a1),d5
	move.w #90*4,d3	;On cherche pas du zoom en X
	sub.w d2,d3
	bpl.s .ok
	add.w #360*4,d3
.ok	muls (cosinus,d3.w),d5	;distance*angle*1024
	asr.l #8,d5
	asr.l #2,d5
	move.l d5,d6
	asr.l #8,d5
	and.l #255,d6
	swap d6
	lsr.l #8,d6
	swap d5
	move.w d6,d5	;D5 haut = pas D5 bas = reste
	
	move.l (a1),d7	;On cherche pas du zoom en Y !
	move.w #90*4,d3	
	sub.w d2,d3
	bpl.s .ok2
	add.w #360*4,d3
.ok2	muls (cosinus+2,d3.w),d7	;distance*angle*1024
	asr.l #8,d7
	asr.l #2,d7
	move.l d7,d6
	asr.l #8,d7
	and.l #255,d7
	swap d6
	lsr.l #8,d6
	swap d7
	move.w d6,d7	;D7 haut = pas D7 bas = reste
	swap d4
	swap d1
	
	moveq #63,d3	;pour 256 points faire :
ll:	
	rept 4
	bfextu d4{10:6},d6	
	lsl.w #8,d6		;*256 car image de 128*64
	lea (image,d6.w),a2		;y
	bfextu d1{9:7},d6
	move.w (a2,d6.w*2),(a0)+	;+x
	add.l d7,d4
	add.l d5,d1
	endr
	dbra d3,ll
	
	add.w #320*2-256*2,a0
	addq.w #4,a1
	dbra d0,next_lig
	rts
	
	SECTION DATA
image	incbin 'e:\asso\fanzine7\jaccard\b2.ntc'
; table *1024 avec 0 = COS 	2 = SINUS
cosinus	incbin 'e:\asso\fanzine7\jaccard\cosinus.tab'
	SECTION BSS
angle	ds.w 1
old_screen	ds.l 1
old_mode	ds.w 1
p_ecran	ds.l 1
ecran	ds.l 160*240
distance	ds.l 100